---
title: Document.createElement()
slug: Web/API/Document/createElement
tags:
  - API
  - DOM
  - Document
  - Method
  - Reference
  - createElement
---
<div>{{APIRef("DOM")}}</div>

<p><span class="seoSummary">In an <a href="/en-US/docs/Web/HTML">HTML</a> document, the <strong><code>document.createElement()</code></strong> method creates the HTML element specified by <var>tagName</var>, or an {{domxref("HTMLUnknownElement")}} if <var>tagName</var> isn't recognized.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js notranslate">let <var>element</var> = <var>document</var>.createElement(<var>tagName</var>[, <var>options</var>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><var>tagName</var></dt>
 <dd>A string that specifies the type of element to be created. The {{domxref("Node.nodeName", "nodeName")}} of the created element is initialized with the value of <var>tagName</var>. Don't use qualified names (like "html:a") with this method. When called on an HTML document, <code>createElement()</code> converts <var>tagName</var> to lower case before creating the element. In Firefox, Opera, and Chrome, <code>createElement(null)</code> works like <code>createElement("null")</code>.</dd>
 <dt><var>options </var>{{optional_inline}}</dt>
 <dd>An optional <code>ElementCreationOptions</code> object, containing a single property named <code>is</code>, whose value is the tag name of a custom element previously defined via <code>customElements.define()</code>. See {{anch("Web component example")}} for more details.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The new {{domxref("Element")}}.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_example">Basic example</h3>

<p>This creates a new <code>&lt;div&gt;</code> and inserts it before the element with the ID "<code>div1</code>".</p>

<h4 id="HTML">HTML</h4>

<pre class="brush:html notranslate">&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
  &lt;title&gt;||Working with elements||&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
  &lt;div id="div1"&gt;The text above has been created dynamically.&lt;/div&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush:js notranslate">document.body.onload = addElement;

function addElement () {
  // create a new div element
  const newDiv = document.createElement("div");

  // and give it some content
  const newContent = document.createTextNode("Hi there and greetings!");

  // add the text node to the newly created div
  newDiv.appendChild(newContent);

  // add the newly created element and its content into the DOM
  const currentDiv = document.getElementById("div1");
  document.body.insertBefore(newDiv, currentDiv);
}</pre>

<p>{{EmbedLiveSample("Basic_example", 500, 50)}}</p>

<h3 id="Web_component_example">Web component example</h3>

<p>The following example snippet is taken from our expanding-list-web-component example (see it live also). In this case, our custom element extends the {{domxref("HTMLUListElement")}}, which represents the {{htmlelement("ul")}} element.</p>

<pre class="brush: js notranslate">// Create a class for the element
class ExpandingList extends HTMLUListElement {
  constructor() {
    // Always call super first in constructor
    super();

    // constructor definition left out for brevity
    ...
  }
}

// Define the new element
customElements.define('expanding-list', ExpandingList, { extends: "ul" });</pre>

<p>If we wanted to create an instance of this element programmatically, we'd use a call along the following lines:</p>

<pre class="brush: js notranslate">let expandingList = document.createElement('ul', { is : 'expanding-list' })</pre>

<p>The new element will be given an <code><a href="/en-US/docs/Web/HTML/Global_attributes/is">is</a></code> attribute whose value is the custom element's tag name.</p>

<div class="note">
<p><strong>Note</strong>: For backwards compatibility with previous versions of the <a href="https://www.w3.org/TR/custom-elements/">Custom Elements specification</a>, some browsers will allow you to pass a string here instead of an object, where the string's value is the custom element's tag name.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', "#dom-document-createelement", "Document.createElement")}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Document.createElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Node.removeChild()")}}</li>
 <li>{{domxref("Node.replaceChild()")}}</li>
 <li>{{domxref("Node.appendChild()")}}</li>
 <li>{{domxref("Node.insertBefore()")}}</li>
 <li>{{domxref("Node.hasChildNodes()")}}</li>
 <li>{{domxref("document.createElementNS()")}} — to explicitly specify the namespace URI for the element.</li>
</ul>
